/* A Bison parser, made by GNU Bison 2.3.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.3"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     IOR_L_NUMBER = 258,
     IOR_L_STRING = 259,
     IOR_L_STRING_WITH_NEWLINE = 260,
     IOR_L_KB = 261,
     IOR_L_MB = 262,
     IOR_L_GB = 263,
     IOR_L_TB = 264,
     IOR_L_PB = 265,
     IOR_L_SECONDS = 266,
     IOR_L_MINUTES = 267,
     IOR_L_HOURS = 268,
     IOR_L_DEVICE = 269,
     IOR_L_PATTERN = 270,
     IOR_L_TEST = 271,
     IOR_L_SEQUENTIAL = 272,
     IOR_L_RANDOM = 273,
     IOR_L_CAPACITY = 274,
     IOR_L_MAXIMUM = 275,
     IOR_L_IGNORE = 276,
     IOR_L_OFFSET = 277,
     IOR_L_BLOCK = 278,
     IOR_L_IOPS = 279,
     IOR_L_WRITE = 280,
     IOR_L_READ = 281,
     IOR_L_SIZE = 282,
     IOR_L_PAUSE = 283,
     IOR_L_FROM = 284,
     IOR_L_FOR = 285,
     IOR_L_IO = 286,
     IOR_L_TARGET = 287,
     IOR_L_AT = 288,
     IOR_L_ONLY = 289,
     IOR_L_TEMP = 290,
     IOR_L_CREATE = 291,
     IOR_L_LOCK = 292,
     IOR_L_ZONE = 293,
     IOR_L_HISTORY = 294,
     IOR_L_REUSE = 295,
     IOR_L_COUNT = 296,
     IOR_L_LIMIT = 297,
     IOR_L_COPY = 298,
     IOR_L_SKEW = 299,
     IOR_L_SEED = 300,
     IOR_L_CORRELATE = 301,
     IOR_L_AREA = 302,
     IOR_L_SHIFT = 303,
     IOR_L_UNKNOWN = 304,
     CAPACITY = 305
   };
#endif
/* Tokens.  */
#define IOR_L_NUMBER 258
#define IOR_L_STRING 259
#define IOR_L_STRING_WITH_NEWLINE 260
#define IOR_L_KB 261
#define IOR_L_MB 262
#define IOR_L_GB 263
#define IOR_L_TB 264
#define IOR_L_PB 265
#define IOR_L_SECONDS 266
#define IOR_L_MINUTES 267
#define IOR_L_HOURS 268
#define IOR_L_DEVICE 269
#define IOR_L_PATTERN 270
#define IOR_L_TEST 271
#define IOR_L_SEQUENTIAL 272
#define IOR_L_RANDOM 273
#define IOR_L_CAPACITY 274
#define IOR_L_MAXIMUM 275
#define IOR_L_IGNORE 276
#define IOR_L_OFFSET 277
#define IOR_L_BLOCK 278
#define IOR_L_IOPS 279
#define IOR_L_WRITE 280
#define IOR_L_READ 281
#define IOR_L_SIZE 282
#define IOR_L_PAUSE 283
#define IOR_L_FROM 284
#define IOR_L_FOR 285
#define IOR_L_IO 286
#define IOR_L_TARGET 287
#define IOR_L_AT 288
#define IOR_L_ONLY 289
#define IOR_L_TEMP 290
#define IOR_L_CREATE 291
#define IOR_L_LOCK 292
#define IOR_L_ZONE 293
#define IOR_L_HISTORY 294
#define IOR_L_REUSE 295
#define IOR_L_COUNT 296
#define IOR_L_LIMIT 297
#define IOR_L_COPY 298
#define IOR_L_SKEW 299
#define IOR_L_SEED 300
#define IOR_L_CORRELATE 301
#define IOR_L_AREA 302
#define IOR_L_SHIFT 303
#define IOR_L_UNKNOWN 304
#define CAPACITY 305




/* Copy the first part of user declarations.  */
#line 1 "ior_pars.y"

/**************************************************************************
 *
 * Yes, the shift/reduce errors from YACC/bison are expected.  It comes
 * from allowing flexible formulas to be used for number data entry, rather
 * than fixed input syntax.  This is a desired result.
 *
 *************************************************************************/

/**************************************************************************
 *
 *  ior_pars.y - the parser for iorate
 *
 *  Copyright by EMC Corporation, 1997-2011.
 *  All rights reserved.
 *
 *  Written by Vince Westin (vince.westin@emc.com), with a lot of
 *  assistance from the EMC Engineering Team.
 *
 *  This code is the property of EMC Corporation.  However, it may be used,
 *  reproduced, and passed on to others as long as the contents, including
 *  all copyright notices, remain intact.  Modifications to, or modified
 *  versions of these files, may also be distributed, provided that they
 *  are clearly labeled as having been modified from the original.  In the
 *  event that modified files are created, the original files are to be
 *  included with every distribution of those modified files.  Inclusion of
 *  this code into a commercial product by any company other than EMC is
 *  prohibited without prior written consent.
 *
 *  Having said the legal stuff, this code is designed to provide a good,
 *  generic tool for testing I/O subsystems under various kinds of loads.
 *  If you have suggestions for improvements in this tool, please send them
 *  along to the above address.
 *
 *************************************************************************/

static char rcsid[] = "$Header: /home/westiv/iorate/RCS/ior_pars.y,v 3.7 2011/11/03 11:13:29 westiv Exp westiv $";

#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <string.h>

#include "iorate.h"


#define	IOR_PCT_BASE	10000.0		/* we pass HUGE, so add some digits */

static ior_config *parse_cfg;		/* config we are parsing for */
static ior_device *parse_dev;		/* device we have parsed */
static ior_device cur_dev;		/* device we are parsing */
static ior_pattern *parse_pat;		/* pattern we have parsed */
static ior_pattern cur_pat;		/* pattern we are parsing */
static ior_test	*parse_test;		/* test we have successfully parsed */
static ior_test	cur_test;		/* test we are parsing */
static int parse_cur_pat;		/* current pattern */
static int parse_pat_pct[ IOR_MAX_PATTERNS + 2 ]; /* pattern allocation */
static HUGE ior_n_size;			/* size we read */
static char *name;			/* name of our item */

extern int yyerror( char *s );



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif

#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef int YYSTYPE;
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 216 of yacc.c.  */
#line 270 "y.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int i)
#else
static int
YYID (i)
    int i;
#endif
{
  return i;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  22
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   263

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  62
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  23
/* YYNRULES -- Number of rules.  */
#define YYNRULES  88
/* YYNRULES -- Number of states.  */
#define YYNSTATES  147

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   305

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,    51,     2,     2,
      58,    59,    56,    54,    53,    55,     2,    57,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,    60,
       2,    50,     2,     2,    52,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    61
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     7,    10,    12,    14,    16,    18,
      21,    28,    35,    42,    50,    53,    54,    57,    60,    64,
      67,    70,    73,    75,    78,    80,    82,    84,    87,    88,
      92,    96,    99,   101,   103,   105,   108,   110,   113,   116,
     119,   122,   125,   128,   131,   134,   137,   140,   143,   146,
     147,   149,   152,   155,   158,   161,   164,   167,   170,   173,
     176,   179,   182,   185,   188,   193,   195,   197,   200,   202,
     203,   205,   207,   211,   215,   219,   223,   227,   230,   233,
     236,   239,   242,   245,   248,   251,   253,   255,   256
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int8 yyrhs[] =
{
      63,     0,    -1,    64,    -1,    65,    -1,    64,    65,    -1,
      66,    -1,    67,    -1,    68,    -1,    69,    -1,     1,    60,
      -1,    14,    80,    50,    83,    70,    60,    -1,    15,    81,
      50,    83,    72,    60,    -1,    16,    80,    50,    83,    74,
      60,    -1,    32,    16,    81,    33,    81,    24,    60,    -1,
      70,    71,    -1,    -1,    22,    78,    -1,    19,    78,    -1,
      23,    27,    78,    -1,    23,    78,    -1,    41,    81,    -1,
      43,    81,    -1,    26,    -1,    26,    34,    -1,    35,    -1,
      36,    -1,    37,    -1,    72,    73,    -1,    -1,    31,    27,
      78,    -1,    20,    17,    81,    -1,    17,    81,    -1,    18,
      -1,    17,    -1,    26,    -1,    26,    79,    -1,    25,    -1,
      25,    79,    -1,    38,    78,    -1,    38,    79,    -1,    41,
      81,    -1,    42,    81,    -1,    40,    79,    -1,    39,    81,
      -1,    29,    78,    -1,    29,    79,    -1,    27,    78,    -1,
      27,    79,    -1,    74,    75,    -1,    -1,    76,    -1,    28,
      77,    -1,    30,    77,    -1,    21,    77,    -1,    81,    24,
      -1,    29,    78,    -1,    29,    79,    -1,    27,    78,    -1,
      27,    79,    -1,    44,    79,    -1,    45,    81,    -1,    48,
      79,    -1,    46,    79,    -1,    47,    78,    -1,    79,    15,
      81,    84,    -1,    82,    -1,    82,    -1,    82,    51,    -1,
      81,    -1,    -1,    82,    -1,     3,    -1,    82,    54,    82,
      -1,    82,    55,    82,    -1,    82,    56,    82,    -1,    82,
      57,    82,    -1,    58,    82,    59,    -1,    82,     6,    -1,
      82,     7,    -1,    82,     8,    -1,    82,     9,    -1,    82,
      10,    -1,    82,    11,    -1,    82,    12,    -1,    82,    13,
      -1,     4,    -1,     5,    -1,    -1,    53,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   137,   137,   142,   143,   146,   147,   148,   149,   150,
     159,   215,   283,   364,   404,   405,   408,   410,   412,   414,
     416,   418,   420,   422,   424,   426,   428,   432,   433,   436,
     438,   440,   442,   444,   446,   448,   450,   452,   454,   456,
     458,   460,   462,   464,   466,   468,   470,   472,   476,   477,
     480,   481,   483,   485,   487,   489,   491,   493,   495,   497,
     499,   501,   503,   505,   509,   536,   540,   545,   549,   552,
     555,   561,   564,   566,   568,   570,   572,   578,   581,   585,
     589,   594,   600,   603,   606,   610,   612,   622,   623
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "IOR_L_NUMBER", "IOR_L_STRING",
  "IOR_L_STRING_WITH_NEWLINE", "IOR_L_KB", "IOR_L_MB", "IOR_L_GB",
  "IOR_L_TB", "IOR_L_PB", "IOR_L_SECONDS", "IOR_L_MINUTES", "IOR_L_HOURS",
  "IOR_L_DEVICE", "IOR_L_PATTERN", "IOR_L_TEST", "IOR_L_SEQUENTIAL",
  "IOR_L_RANDOM", "IOR_L_CAPACITY", "IOR_L_MAXIMUM", "IOR_L_IGNORE",
  "IOR_L_OFFSET", "IOR_L_BLOCK", "IOR_L_IOPS", "IOR_L_WRITE", "IOR_L_READ",
  "IOR_L_SIZE", "IOR_L_PAUSE", "IOR_L_FROM", "IOR_L_FOR", "IOR_L_IO",
  "IOR_L_TARGET", "IOR_L_AT", "IOR_L_ONLY", "IOR_L_TEMP", "IOR_L_CREATE",
  "IOR_L_LOCK", "IOR_L_ZONE", "IOR_L_HISTORY", "IOR_L_REUSE",
  "IOR_L_COUNT", "IOR_L_LIMIT", "IOR_L_COPY", "IOR_L_SKEW", "IOR_L_SEED",
  "IOR_L_CORRELATE", "IOR_L_AREA", "IOR_L_SHIFT", "IOR_L_UNKNOWN", "'='",
  "'%'", "'@'", "','", "'+'", "'-'", "'*'", "'/'", "'('", "')'", "';'",
  "CAPACITY", "$accept", "config", "file_lines", "file_line", "dev_line",
  "pat_line", "test_line", "iops_line", "dev_args", "dev_arg", "pat_args",
  "pat_arg", "test_args", "test_arg", "pat_pct", "time", "size", "pct",
  "opt_number", "number", "expr", "name", "comma", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
      61,    37,    64,    44,    43,    45,    42,    47,    40,    41,
      59,   305
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    62,    63,    64,    64,    65,    65,    65,    65,    65,
      66,    67,    68,    69,    70,    70,    71,    71,    71,    71,
      71,    71,    71,    71,    71,    71,    71,    72,    72,    73,
      73,    73,    73,    73,    73,    73,    73,    73,    73,    73,
      73,    73,    73,    73,    73,    73,    73,    73,    74,    74,
      75,    75,    75,    75,    75,    75,    75,    75,    75,    75,
      75,    75,    75,    75,    76,    77,    78,    79,    80,    80,
      81,    82,    82,    82,    82,    82,    82,    82,    82,    82,
      82,    82,    82,    82,    82,    83,    83,    84,    84
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     1,     2,     1,     1,     1,     1,     2,
       6,     6,     6,     7,     2,     0,     2,     2,     3,     2,
       2,     2,     1,     2,     1,     1,     1,     2,     0,     3,
       3,     2,     1,     1,     1,     2,     1,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     0,
       1,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     4,     1,     1,     2,     1,     0,
       1,     1,     3,     3,     3,     3,     3,     2,     2,     2,
       2,     2,     2,     2,     2,     1,     1,     0,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,     0,    69,     0,    69,     0,     0,     0,     3,     5,
       6,     7,     8,     9,    71,     0,     0,    68,    70,     0,
       0,     0,     1,     4,     0,     0,    77,    78,    79,    80,
      81,    82,    83,    84,     0,     0,     0,     0,     0,     0,
       0,    76,    85,    86,    15,    72,    73,    74,    75,    28,
      49,     0,     0,     0,     0,     0,     0,     0,     0,    22,
      24,    25,    26,     0,     0,    10,    14,    33,    32,     0,
      36,    34,     0,     0,     0,     0,     0,     0,     0,     0,
      11,    27,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    12,    48,    50,     0,     0,    70,     0,    17,
      66,    16,     0,    19,    23,    20,    21,    31,     0,    37,
       0,    35,    46,    47,    66,    44,    45,     0,    38,    39,
      43,    42,    40,    41,    53,    65,    57,    58,    51,    55,
      56,    52,    59,    60,    62,    63,    61,     0,    54,    67,
      13,    18,    30,    29,    87,    88,    64
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     6,     7,     8,     9,    10,    11,    12,    52,    66,
      53,    81,    54,    93,    94,   124,    99,    95,    16,    17,
      18,    44,   146
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -78
static const yytype_int16 yypact[] =
{
      38,   -52,    -1,    -1,    -1,    -4,    13,     5,   -78,   -78,
     -78,   -78,   -78,   -78,   -78,    -1,   -34,   -78,   140,   -33,
     -28,    -1,   -78,   -78,   110,     6,   -78,   -78,   -78,   -78,
     -78,   -78,   -78,   -78,    -1,    -1,    -1,    -1,     6,     6,
     -10,   -78,   -78,   -78,   -78,   148,   148,   164,   164,   -78,
     -78,    -1,   192,   181,    85,     2,    -1,    -1,    -2,    -7,
     -78,   -78,   -78,    -1,    -1,   -78,   -78,    -1,   -78,    11,
      -1,    -1,    -1,    -1,     4,    -1,    -1,    -1,    -1,    -1,
     -78,   -78,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   -78,   -78,   -78,    18,    10,   129,   -25,   -78,
     140,   -78,    -1,   -78,   -78,   -78,   -78,   -78,    -1,   -78,
     129,   -78,   -78,   -78,   129,   -78,   -78,    -1,   -78,   -78,
     -78,   -78,   -78,   -78,   -78,   140,   -78,   -78,   -78,   -78,
     -78,   -78,   -78,   -78,   -78,   -78,   -78,    -1,   -78,   -78,
     -78,   -78,   -78,   -78,   -17,   -78,   -78
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
     -78,   -78,   -78,    31,   -78,   -78,   -78,   -78,   -78,   -78,
     -78,   -78,   -78,   -78,   -78,   -77,   -43,   172,    37,    -3,
       9,   -35,   -78
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -3
static const yytype_int16 yytable[] =
{
      19,    14,    14,    49,    50,    -2,     1,   128,    13,   131,
      42,    43,    21,    22,   101,   103,    25,    38,    40,     2,
       3,     4,    39,    51,    24,   102,    98,   104,   108,   112,
     115,   117,   118,   137,   138,   140,   145,     5,    23,     1,
     126,    20,   129,    45,    46,    47,    48,   135,    55,     0,
       0,    96,     2,     3,     4,     0,    15,    15,     0,   141,
     105,   106,     0,    97,   107,   100,   100,   100,     0,     0,
       5,     0,     0,   120,   143,   122,   123,     0,     0,   110,
     110,   114,   114,     0,   114,   133,   110,     0,    14,     0,
       0,   125,   114,   125,   114,   125,   110,     0,   110,   100,
     110,     0,     0,     0,     0,   142,    82,     0,     0,     0,
       0,   100,    83,    84,    85,    86,    26,    27,    28,    29,
      30,    31,    32,    33,     0,     0,   100,     0,     0,    87,
      88,    89,    90,    91,   144,    26,    27,    28,    29,    30,
      31,    32,    33,    15,     0,    92,    26,    27,    28,    29,
      30,    31,    32,    33,    26,    27,    28,    29,    30,    31,
      32,    33,     0,     0,    34,    35,    36,    37,     0,    41,
      26,    27,    28,    29,    30,    31,    32,    33,     0,     0,
     139,     0,     0,    34,    35,    36,    37,     0,     0,     0,
       0,     0,     0,     0,    34,    35,    36,    37,    67,    68,
       0,    69,     0,     0,    36,    37,    70,    71,    72,     0,
      73,    56,    74,     0,    57,    58,     0,     0,    59,    75,
      76,    77,    78,    79,     0,     0,     0,    60,    61,    62,
       0,     0,     0,    63,     0,    64,     0,     0,     0,     0,
       0,    80,   109,   111,   113,   116,     0,   119,     0,   121,
       0,     0,    65,     0,     0,   127,     0,   130,     0,   132,
       0,   134,     0,   136
};

static const yytype_int16 yycheck[] =
{
       3,     3,     3,    38,    39,     0,     1,    84,    60,    86,
       4,     5,    16,     0,    57,    58,    50,    50,    21,    14,
      15,    16,    50,    33,    15,    27,    24,    34,    17,    72,
      73,    27,    75,    15,    24,    60,    53,    32,     7,     1,
      83,     4,    85,    34,    35,    36,    37,    90,    51,    -1,
      -1,    54,    14,    15,    16,    -1,    58,    58,    -1,   102,
      63,    64,    -1,    54,    67,    56,    57,    58,    -1,    -1,
      32,    -1,    -1,    76,   117,    78,    79,    -1,    -1,    70,
      71,    72,    73,    -1,    75,    88,    77,    -1,     3,    -1,
      -1,    82,    83,    84,    85,    86,    87,    -1,    89,    90,
      91,    -1,    -1,    -1,    -1,   108,    21,    -1,    -1,    -1,
      -1,   102,    27,    28,    29,    30,     6,     7,     8,     9,
      10,    11,    12,    13,    -1,    -1,   117,    -1,    -1,    44,
      45,    46,    47,    48,   137,     6,     7,     8,     9,    10,
      11,    12,    13,    58,    -1,    60,     6,     7,     8,     9,
      10,    11,    12,    13,     6,     7,     8,     9,    10,    11,
      12,    13,    -1,    -1,    54,    55,    56,    57,    -1,    59,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    -1,
      51,    -1,    -1,    54,    55,    56,    57,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    54,    55,    56,    57,    17,    18,
      -1,    20,    -1,    -1,    56,    57,    25,    26,    27,    -1,
      29,    19,    31,    -1,    22,    23,    -1,    -1,    26,    38,
      39,    40,    41,    42,    -1,    -1,    -1,    35,    36,    37,
      -1,    -1,    -1,    41,    -1,    43,    -1,    -1,    -1,    -1,
      -1,    60,    70,    71,    72,    73,    -1,    75,    -1,    77,
      -1,    -1,    60,    -1,    -1,    83,    -1,    85,    -1,    87,
      -1,    89,    -1,    91
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     1,    14,    15,    16,    32,    63,    64,    65,    66,
      67,    68,    69,    60,     3,    58,    80,    81,    82,    81,
      80,    16,     0,    65,    82,    50,     6,     7,     8,     9,
      10,    11,    12,    13,    54,    55,    56,    57,    50,    50,
      81,    59,     4,     5,    83,    82,    82,    82,    82,    83,
      83,    33,    70,    72,    74,    81,    19,    22,    23,    26,
      35,    36,    37,    41,    43,    60,    71,    17,    18,    20,
      25,    26,    27,    29,    31,    38,    39,    40,    41,    42,
      60,    73,    21,    27,    28,    29,    30,    44,    45,    46,
      47,    48,    60,    75,    76,    79,    81,    82,    24,    78,
      82,    78,    27,    78,    34,    81,    81,    81,    17,    79,
      82,    79,    78,    79,    82,    78,    79,    27,    78,    79,
      81,    79,    81,    81,    77,    82,    78,    79,    77,    78,
      79,    77,    79,    81,    79,    78,    79,    15,    24,    51,
      60,    78,    81,    78,    81,    53,    84
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *bottom, yytype_int16 *top)
#else
static void
yy_stack_print (bottom, top)
    yytype_int16 *bottom;
    yytype_int16 *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      fprintf (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      fprintf (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The look-ahead symbol.  */
int yychar;

/* The semantic value of the look-ahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  int yystate;
  int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Look-ahead token as an internal (translated) token number.  */
  int yytoken = 0;
#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  yytype_int16 yyssa[YYINITDEPTH];
  yytype_int16 *yyss = yyssa;
  yytype_int16 *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  YYSTYPE *yyvsp;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     look-ahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to look-ahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a look-ahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid look-ahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the look-ahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 138 "ior_pars.y"
    { ior_debug( parse_cfg, "parsed a valid config" );
	    return( 0 ); ;}
    break;

  case 9:
#line 151 "ior_pars.y"
    {
		ior_parse_dev_clear( parse_cfg ); /* clean up any input */
		ior_parse_pat_clear( parse_cfg );
		ior_parse_test_clear( parse_cfg );
		yyerrok;
	    ;}
    break;

  case 10:
#line 160 "ior_pars.y"
    {
		name = (char *)((long)( (yyvsp[(4) - (6)]) ));
		sprintf( msg_buf, "parsed DEV: %d = %s %dk %dk %dk",
			(int) (yyvsp[(2) - (6)]), name,
			(int)( cur_dev.d_offset / 1024 ),
			(int)( cur_dev.d_capacity / 1024 ),
			(int)( cur_dev.d_block_size / 1024 ));
		ior_debug( parse_cfg, msg_buf );

		if ( (yyvsp[(2) - (6)]) == -1 ) {	/* create a device ID */
		    (yyvsp[(2) - (6)]) = ++parse_cfg->c_ndev;
		};

		if (( (yyvsp[(2) - (6)]) < 1 ) || ( (yyvsp[(2) - (6)]) > IOR_MAX_DEVICES )) {
		    sprintf( msg_buf, "%s: %d: Invalid device number (%d)",
			    parse_cfg->c_l_name, parse_cfg->c_l_line,
			    (int) (yyvsp[(2) - (6)]) );
		    ior_error( parse_cfg, msg_buf );
		} else {
		    if ( parse_cfg->c_ndev < (yyvsp[(2) - (6)]) ) {
			parse_cfg->c_ndev = (yyvsp[(2) - (6)]);
		    };

		    parse_dev = &( parse_cfg->c_devs[ (yyvsp[(2) - (6)]) - 1 ]);

		    if ( parse_dev->d_valid ) {
			sprintf( msg_buf,
				"%s: %d: Redefinition of device %d (was %s)",
				parse_cfg->c_l_name, parse_cfg->c_l_line,
				(int) (yyvsp[(2) - (6)]), parse_dev->d_name );
			ior_warn( parse_cfg, msg_buf );
			free( parse_dev->d_name );
		    };

		    parse_dev->d_name = name;
		    parse_dev->d_valid = 1; /* mark as valid */

		    parse_dev->d_offset = cur_dev.d_offset;
		    parse_dev->d_capacity = cur_dev.d_capacity;
		    parse_dev->d_block_size = cur_dev.d_block_size;
		    parse_dev->d_is_async = cur_dev.d_is_async;
		    parse_dev->d_read_only = cur_dev.d_read_only;
		    parse_dev->d_is_temp = cur_dev.d_is_temp;
		    parse_dev->d_create = cur_dev.d_create;
		    parse_dev->d_lock = cur_dev.d_lock;
		    parse_dev->d_count = cur_dev.d_count;

		    ior_debug( parse_cfg, "parsed a valid device" );
		};
					/* clear out parsing data area */
		ior_parse_dev_clear( parse_cfg );
	    ;}
    break;

  case 11:
#line 216 "ior_pars.y"
    {
		name = (char *)((long)( (yyvsp[(4) - (6)]) ));
		sprintf( msg_buf,
			"parsed PAT: %d = %s %dK %d %d %d%% %dK %d%% %dK %d%% %dK %d%% %d %d %d %d%%",
			(int) (yyvsp[(2) - (6)]), name,
			(int)( cur_pat.p_io_size / 1024 ),
			(int) cur_pat.p_max_seq,
			(int) cur_pat.p_is_seq,
			(int) cur_pat.p_read_pct,
			(int)( cur_pat.p_start / 1024 ),
			(int) cur_pat.p_start_pct,
			(int)( cur_pat.p_size / 1024 ),
			(int) cur_pat.p_size_pct,
		    	(int)( cur_pat.p_local_size / 1024 ),
		    	(int) cur_pat.p_local_pct,
		    	(int) cur_pat.p_local_count,
		    	(int) cur_pat.p_local_limit,
		    	(int) cur_pat.p_history,
		    	(int) cur_pat.p_reuse_pct );
		ior_debug( parse_cfg, msg_buf );
		if (( (yyvsp[(2) - (6)]) < 1 ) || ( (yyvsp[(2) - (6)]) > IOR_MAX_PATTERNS )) {
		    sprintf( msg_buf, "%s: %d: Invalid pattern number (%d)",
			    parse_cfg->c_l_name, parse_cfg->c_l_line,
			    (int) (yyvsp[(2) - (6)]) );
		    ior_error( parse_cfg, msg_buf );
		} else {
		    if ( parse_cfg->c_npat < (yyvsp[(2) - (6)]) ) {
			parse_cfg->c_npat = (yyvsp[(2) - (6)]);
		    };

		    parse_pat = &( parse_cfg->c_pats[ (yyvsp[(2) - (6)]) - 1 ]);

		    if ( parse_pat->p_valid ) {
			sprintf( msg_buf,
				"%s: %d: Redefinition of pattern %d (was %s)",
				parse_cfg->c_l_name, parse_cfg->c_l_line,
				(int) (yyvsp[(2) - (6)]), parse_pat->p_name );
			ior_warn( parse_cfg, msg_buf );
			free( parse_pat->p_name );
		    };

		    parse_pat->p_name = name;
		    parse_pat->p_end = -1; /* know where the end is */
		    parse_pat->p_valid = 1; /* mark as valid */

		    parse_pat->p_io_size = cur_pat.p_io_size;
		    parse_pat->p_max_seq = cur_pat.p_max_seq;
		    parse_pat->p_is_seq = cur_pat.p_is_seq;
		    parse_pat->p_read_pct = cur_pat.p_read_pct;
		    parse_pat->p_start = cur_pat.p_start;
		    parse_pat->p_start_pct = cur_pat.p_start_pct;
		    parse_pat->p_size = cur_pat.p_size;
		    parse_pat->p_size_pct = cur_pat.p_size_pct;
		    parse_pat->p_local_size = cur_pat.p_local_size;
		    parse_pat->p_local_pct = cur_pat.p_local_pct;
		    parse_pat->p_local_count = cur_pat.p_local_count;
		    parse_pat->p_local_limit = cur_pat.p_local_limit;
		    parse_pat->p_history = cur_pat.p_history;
		    parse_pat->p_reuse_pct = cur_pat.p_reuse_pct;

		    ior_debug( parse_cfg, "parsed a valid pattern" );
		};
					/* clear out parsing data area */
		ior_parse_pat_clear( parse_cfg );
	    ;}
    break;

  case 12:
#line 284 "ior_pars.y"
    {
		name = (char *)((long)( (yyvsp[(4) - (6)]) ));
		sprintf( msg_buf, "parsed TEST: %d = %s %d %d %d %d %dk %dk",
			(int) (yyvsp[(2) - (6)]), name,
			(int) cur_test.t_pause,
			(int) cur_test.t_duration,
			(int) cur_test.t_ignore,
			(int) cur_test.t_iops,
			(int)( cur_test.t_start / 1024 ),
			(int)( cur_test.t_size / 1024 ));
		ior_debug( parse_cfg, msg_buf );
		sprintf( msg_buf, "    TEST : skew %d%%, seed %d, shift %d%%, cor %d%%, area %dk",
			(int) cur_test.t_skew,
			(int) cur_test.t_seed,
			(int) cur_test.t_shift,
			(int) cur_test.t_correlate,
			(int)( cur_test.t_area / 1024 ));
		ior_debug( parse_cfg, msg_buf );

		if ( (yyvsp[(2) - (6)]) == -1 ) {	/* create a test ID */
		    (yyvsp[(2) - (6)]) = ++parse_cfg->c_ntest;
		};

		if (( (yyvsp[(2) - (6)]) < 1 ) || ( (yyvsp[(2) - (6)]) > IOR_MAX_TESTS )) {
		    sprintf( msg_buf, "%s: %d: Invalid test number (%d)",
			    parse_cfg->c_l_name, parse_cfg->c_l_line,
			    (int) (yyvsp[(2) - (6)]) );
		    ior_error( parse_cfg, msg_buf );
		} else {
		    if ( parse_cfg->c_ntest < (yyvsp[(2) - (6)]) ) {
			parse_cfg->c_ntest = (yyvsp[(2) - (6)]);
		    };

		    parse_test = &( parse_cfg->c_tests[ (yyvsp[(2) - (6)]) - 1 ]);

		    if ( parse_test->t_valid ) {
			sprintf( msg_buf,
				"%s: %d: Redefinition of test %d (was %s)",
				parse_cfg->c_l_name, parse_cfg->c_l_line,
				(int) (yyvsp[(2) - (6)]), parse_test->t_name );
			ior_warn( parse_cfg, msg_buf );
			free( parse_test->t_name );
		    };

		    parse_test->t_name = name;
		    parse_test->t_valid = 1; /* mark as valid */

		    parse_test->t_pause = cur_test.t_pause;
		    parse_test->t_duration = cur_test.t_duration;
		    parse_test->t_ignore = cur_test.t_ignore;
		    parse_test->t_iops = cur_test.t_iops;
		    parse_test->t_start = cur_test.t_start;
		    parse_test->t_start_pct = cur_test.t_start_pct;
		    parse_test->t_size = cur_test.t_size;
		    parse_test->t_size_pct = cur_test.t_size_pct;

		    parse_test->t_skew = cur_test.t_skew;
		    parse_test->t_seed = cur_test.t_seed;
		    parse_test->t_shift = cur_test.t_shift;
		    parse_test->t_correlate = cur_test.t_correlate;
		    parse_test->t_area = cur_test.t_area;

					/* save pattern percentages */
		    for ( parse_cur_pat = 0;
			    parse_cur_pat < IOR_MAX_PATTERNS;
			    parse_cur_pat++ ) {

					/* save current pattern percent */
			parse_test->t_pat_pct[ parse_cur_pat ] =
				parse_pat_pct[ parse_cur_pat ];
		    };

		    ior_debug( parse_cfg, "parsed a valid test" );
		};

					/* clear out parsing data area */
		ior_parse_test_clear( parse_cfg );
	    ;}
    break;

  case 13:
#line 365 "ior_pars.y"
    {
		sprintf( msg_buf, "parsed IOPS: Test %d @ %d",
			(int) (yyvsp[(3) - (7)]), (int) (yyvsp[(5) - (7)]) );
		ior_debug( parse_cfg, msg_buf );
		if (( (yyvsp[(3) - (7)]) < 1 ) || ( (yyvsp[(3) - (7)]) > IOR_MAX_TESTS )) {
		    sprintf( msg_buf, "%s: %d: Invalid test number (%d)",
			    parse_cfg->c_l_name, parse_cfg->c_l_line,
			    (int) (yyvsp[(3) - (7)]) );
		    ior_error( parse_cfg, msg_buf );
		} else {
		    parse_test = &( parse_cfg->c_tests[ (yyvsp[(3) - (7)]) - 1 ]);

		    if ( !parse_test->t_valid ) {
			sprintf( msg_buf,
				"%s: %d: iops for invalid test (%d)",
				parse_cfg->c_l_name, parse_cfg->c_l_line,
				(int) (yyvsp[(3) - (7)]) );
			ior_warn( parse_cfg, msg_buf );
		    } else {
			if ( (yyvsp[(5) - (7)]) < 0 ) {
			    sprintf( msg_buf,
				    "Invalid iops target (%d) for test %d (ignored)",
				    (int) (yyvsp[(5) - (7)]), (int)( (yyvsp[(3) - (7)]) + 1 ));
			    ior_warn( parse_cfg, msg_buf );
			} else {
			    if ( parse_test->t_iops > 0 ) {
				sprintf( msg_buf, "IOPS for test %d previously set to %ld",
					(int)( (yyvsp[(3) - (7)]) + 1 ), parse_test->t_iops );
				ior_debug( parse_cfg, msg_buf );
			    };
			    parse_test->t_iops = (yyvsp[(5) - (7)]);
			};
		    };

		    ior_debug( parse_cfg, "parsed a valid iops" );
		};
	    ;}
    break;

  case 16:
#line 409 "ior_pars.y"
    { cur_dev.d_offset = (yyvsp[(2) - (2)]); ;}
    break;

  case 17:
#line 411 "ior_pars.y"
    { cur_dev.d_capacity = (yyvsp[(2) - (2)]); ;}
    break;

  case 18:
#line 413 "ior_pars.y"
    { cur_dev.d_block_size = (yyvsp[(3) - (3)]); ;}
    break;

  case 19:
#line 415 "ior_pars.y"
    { cur_dev.d_block_size = (yyvsp[(2) - (2)]); ;}
    break;

  case 20:
#line 417 "ior_pars.y"
    { cur_dev.d_count = (yyvsp[(2) - (2)]); ;}
    break;

  case 21:
#line 419 "ior_pars.y"
    { cur_dev.d_count = (yyvsp[(2) - (2)]); ;}
    break;

  case 22:
#line 421 "ior_pars.y"
    { cur_dev.d_read_only = 1; ;}
    break;

  case 23:
#line 423 "ior_pars.y"
    { cur_dev.d_read_only = 1; ;}
    break;

  case 24:
#line 425 "ior_pars.y"
    { cur_dev.d_is_temp = 1; ;}
    break;

  case 25:
#line 427 "ior_pars.y"
    { cur_dev.d_create = 1; ;}
    break;

  case 26:
#line 429 "ior_pars.y"
    { cur_dev.d_lock = 1; ;}
    break;

  case 29:
#line 437 "ior_pars.y"
    { cur_pat.p_io_size = (yyvsp[(3) - (3)]); ;}
    break;

  case 30:
#line 439 "ior_pars.y"
    { cur_pat.p_max_seq = (yyvsp[(3) - (3)]); ;}
    break;

  case 31:
#line 441 "ior_pars.y"
    { cur_pat.p_max_seq = (yyvsp[(2) - (2)]); ;}
    break;

  case 32:
#line 443 "ior_pars.y"
    { cur_pat.p_is_seq = 0; ;}
    break;

  case 33:
#line 445 "ior_pars.y"
    { cur_pat.p_is_seq = 1; ;}
    break;

  case 34:
#line 447 "ior_pars.y"
    { cur_pat.p_read_pct = 100; ;}
    break;

  case 35:
#line 449 "ior_pars.y"
    { cur_pat.p_read_pct = (int)(( (yyvsp[(2) - (2)]) / IOR_PCT_BASE ) + 0.5 ); ;}
    break;

  case 36:
#line 451 "ior_pars.y"
    { cur_pat.p_read_pct = 0; ;}
    break;

  case 37:
#line 453 "ior_pars.y"
    { cur_pat.p_read_pct = (int)( 100.5 - ( (yyvsp[(2) - (2)]) / IOR_PCT_BASE )); ;}
    break;

  case 38:
#line 455 "ior_pars.y"
    { cur_pat.p_local_size = (yyvsp[(2) - (2)]); ;}
    break;

  case 39:
#line 457 "ior_pars.y"
    { cur_pat.p_local_pct = ( (yyvsp[(2) - (2)]) / IOR_PCT_BASE ); ;}
    break;

  case 40:
#line 459 "ior_pars.y"
    { cur_pat.p_local_count = (yyvsp[(2) - (2)]); ;}
    break;

  case 41:
#line 461 "ior_pars.y"
    { cur_pat.p_local_limit = (yyvsp[(2) - (2)]); ;}
    break;

  case 42:
#line 463 "ior_pars.y"
    { cur_pat.p_reuse_pct = ( (yyvsp[(2) - (2)]) / IOR_PCT_BASE ); ;}
    break;

  case 43:
#line 465 "ior_pars.y"
    { cur_pat.p_history = (yyvsp[(2) - (2)]); ;}
    break;

  case 44:
#line 467 "ior_pars.y"
    { cur_pat.p_start = (yyvsp[(2) - (2)]); ;}
    break;

  case 45:
#line 469 "ior_pars.y"
    { cur_pat.p_start_pct = ( (yyvsp[(2) - (2)]) / IOR_PCT_BASE ); ;}
    break;

  case 46:
#line 471 "ior_pars.y"
    { cur_pat.p_size = (yyvsp[(2) - (2)]); ;}
    break;

  case 47:
#line 473 "ior_pars.y"
    { cur_pat.p_size_pct = ( (yyvsp[(2) - (2)]) / IOR_PCT_BASE ); ;}
    break;

  case 51:
#line 482 "ior_pars.y"
    { cur_test.t_pause = (yyvsp[(2) - (2)]); ;}
    break;

  case 52:
#line 484 "ior_pars.y"
    { cur_test.t_duration = (yyvsp[(2) - (2)]); ;}
    break;

  case 53:
#line 486 "ior_pars.y"
    { cur_test.t_ignore = (yyvsp[(2) - (2)]); ;}
    break;

  case 54:
#line 488 "ior_pars.y"
    { cur_test.t_iops = (yyvsp[(1) - (2)]); ;}
    break;

  case 55:
#line 490 "ior_pars.y"
    { cur_test.t_start = (yyvsp[(2) - (2)]); ;}
    break;

  case 56:
#line 492 "ior_pars.y"
    { cur_test.t_start_pct = (int)(( (yyvsp[(2) - (2)]) / IOR_PCT_BASE ) + 0.5 ); ;}
    break;

  case 57:
#line 494 "ior_pars.y"
    { cur_test.t_size = (yyvsp[(2) - (2)]); ;}
    break;

  case 58:
#line 496 "ior_pars.y"
    { cur_test.t_size_pct = (int)(( (yyvsp[(2) - (2)]) / IOR_PCT_BASE ) + 0.5 ); ;}
    break;

  case 59:
#line 498 "ior_pars.y"
    { cur_test.t_skew = (int)(( (yyvsp[(2) - (2)]) / IOR_PCT_BASE ) + 0.5 ); ;}
    break;

  case 60:
#line 500 "ior_pars.y"
    { cur_test.t_seed = (yyvsp[(2) - (2)]); ;}
    break;

  case 61:
#line 502 "ior_pars.y"
    { cur_test.t_shift = (int)(( (yyvsp[(2) - (2)]) / IOR_PCT_BASE ) + 0.5 ); ;}
    break;

  case 62:
#line 504 "ior_pars.y"
    { cur_test.t_correlate = (int)(( (yyvsp[(2) - (2)]) / IOR_PCT_BASE ) + 0.5 ); ;}
    break;

  case 63:
#line 506 "ior_pars.y"
    { cur_test.t_area = (yyvsp[(2) - (2)]); ;}
    break;

  case 64:
#line 510 "ior_pars.y"
    {
		(yyvsp[(1) - (4)]) = (long int)((yyvsp[(1) - (4)]) / IOR_PCT_BASE);
		sprintf( msg_buf, "parsed PAT_PCT: %d%% pat %d",
			(int) (yyvsp[(1) - (4)]), (int) (yyvsp[(3) - (4)]) );
		ior_debug( parse_cfg, msg_buf );
		if (( (yyvsp[(3) - (4)]) < 1 ) || ( (yyvsp[(3) - (4)]) > IOR_MAX_PATTERNS )) {
		    sprintf( msg_buf,
			    "%s: %d: Invalid pattern number for %% (%d)",
			    parse_cfg->c_l_name, parse_cfg->c_l_line,
			    (int) (yyvsp[(3) - (4)]) );
		    ior_error( parse_cfg, msg_buf );
		} else {
		    parse_cur_pat = (yyvsp[(3) - (4)]) - 1;
		    if ( parse_pat_pct[ parse_cur_pat ] != 0 ) {
			sprintf( msg_buf,
				"%s: %d: Redefinition of %% for pattern %d (was %d)",
				parse_cfg->c_l_name, parse_cfg->c_l_line,
				(int) (yyvsp[(3) - (4)]), parse_pat_pct[ (yyvsp[(3) - (4)]) ]);
			ior_warn( parse_cfg, msg_buf );
		    };

		    parse_pat_pct[ parse_cur_pat ] = (yyvsp[(1) - (4)]);
		};
	    ;}
    break;

  case 65:
#line 537 "ior_pars.y"
    { (yyval) = (yyvsp[(1) - (1)]) / 1024L; ;}
    break;

  case 66:
#line 541 "ior_pars.y"
    { (yyval) = (yyvsp[(1) - (1)]) / 1024L; ;}
    break;

  case 67:
#line 546 "ior_pars.y"
    { (yyval) = (yyvsp[(1) - (2)]) / 1024L * IOR_PCT_BASE; ;}
    break;

  case 68:
#line 550 "ior_pars.y"
    { (yyval) = (yyvsp[(1) - (1)]); ;}
    break;

  case 69:
#line 552 "ior_pars.y"
    { (yyval) = -1; ;}
    break;

  case 70:
#line 556 "ior_pars.y"
    { (yyval) = (yyvsp[(1) - (1)]) / 1024L; ;}
    break;

  case 71:
#line 562 "ior_pars.y"
    { (yyval) = parse_cfg->c_l_value * 1024L ; ;}
    break;

  case 72:
#line 565 "ior_pars.y"
    { (yyval) = (yyvsp[(1) - (3)]) + (yyvsp[(3) - (3)]); ;}
    break;

  case 73:
#line 567 "ior_pars.y"
    { (yyval) = (yyvsp[(1) - (3)]) - (yyvsp[(3) - (3)]); ;}
    break;

  case 74:
#line 569 "ior_pars.y"
    { (yyval) = (yyvsp[(1) - (3)]) * (yyvsp[(3) - (3)]); ;}
    break;

  case 75:
#line 571 "ior_pars.y"
    { (yyval) = (yyvsp[(1) - (3)]) / (yyvsp[(3) - (3)]); ;}
    break;

  case 76:
#line 573 "ior_pars.y"
    { (yyval) = (yyvsp[(2) - (3)]); ;}
    break;

  case 77:
#line 579 "ior_pars.y"
    { (yyval) = (yyvsp[(1) - (2)]) * 1024; ;}
    break;

  case 78:
#line 582 "ior_pars.y"
    { ior_n_size = (yyvsp[(1) - (2)]) * 1024;
		    (yyval) = 1024 * ior_n_size; ;}
    break;

  case 79:
#line 586 "ior_pars.y"
    { ior_n_size = (yyvsp[(1) - (2)]) * 1024;
		    (yyval) = 1024 * 1024 * ior_n_size; ;}
    break;

  case 80:
#line 590 "ior_pars.y"
    { ior_n_size = (yyvsp[(1) - (2)]) * 1024;
		    ior_n_size *= 1024 * 1024;
		    (yyval) = 1024 * ior_n_size; ;}
    break;

  case 81:
#line 595 "ior_pars.y"
    { ior_n_size = (yyvsp[(1) - (2)]) * 1024;
		    ior_n_size *= 1024 * 1024;
		    (yyval) = 1024 * 1024 * ior_n_size; ;}
    break;

  case 82:
#line 601 "ior_pars.y"
    { (yyval) = (yyvsp[(1) - (2)]); ;}
    break;

  case 83:
#line 604 "ior_pars.y"
    { (yyval) = (yyvsp[(1) - (2)]) * 60; ;}
    break;

  case 84:
#line 607 "ior_pars.y"
    { (yyval) = (yyvsp[(1) - (2)]) * 60 * 60; ;}
    break;

  case 85:
#line 611 "ior_pars.y"
    { (yyval) = (long) ior_strdup( parse_cfg, parse_cfg->c_l_str ); ;}
    break;

  case 86:
#line 613 "ior_pars.y"
    {
		sprintf( msg_buf,
			"%s: %d: Invalid string (includes newline)",
			parse_cfg->c_l_name, parse_cfg->c_l_line );
		ior_error( parse_cfg, msg_buf );
		(yyval) = (long) ior_strdup( parse_cfg, "INVALID STRING" );
	    ;}
    break;


/* Line 1267 of yacc.c.  */
#line 2258 "y.tab.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse look-ahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse look-ahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEOF && yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


#line 626 "ior_pars.y"


#include <stdio.h>

extern FILE *yyin;

/*
 * ior_parse_prep - prepare to parse a file
 */
int	ior_parse_prep(ior_config *cfg, char *f_name )
/* ior_config	*cfg;			 our configuration */
/* char		*f_name;		 name of file we will use */
{
    int		result;			/* final return code */

    result = strlen( rcsid );		/* STOP unused complaints from compiler */
    result = 0;				/* all OK so far */

    sprintf( msg_buf, "Beginning parse of file '%s'", f_name );
    ior_debug( cfg, msg_buf );

    cfg->c_l_name = f_name;
    cfg->c_l_line = 1;

    parse_cfg = cfg;			/* remember the config we are in */

    result = ior_lex_prep( cfg );	/* prepare lexical analyzer */
    if ( result ) {
	return( result );
    };
					/* open file for reading */
    if (( yyin = fopen( f_name, "r" )) == NULL ) {
	perror( f_name );
	sprintf( msg_buf, "Unable to open information file '%s'",
		f_name );
	ior_error( cfg, msg_buf );

	result = -1;
    };

    ior_parse_dev_clear( cfg );		/* clear device info */
    ior_parse_pat_clear( cfg );		/* clear pattern info */
    ior_parse_test_clear( cfg );	/* clear test info */

    return( result );
}

/*
 * ior_parse_dev_clear - clear out device read area
 */
int	ior_parse_dev_clear( ior_config *cfg )
/* ior_config	*cfg;			 our configuration */
{
    int		result;			/* final return code */

    result = 0;				/* all OK so far */

					/* clear out parsing data areas */
    memset( &cur_dev, '\0', sizeof( ior_device ));

    cur_dev.d_offset = IOR_MIN_POS;	/* default to min. offset */
    cur_dev.d_block_size = IOR_BLOCK_SIZE; /* default to min. block size */
    cur_dev.d_count = 1;		/* only one copy */

    return( result );
}

/*
 * ior_parse_pat_clear - clear out pattern read area
 */
int	ior_parse_pat_clear( ior_config *cfg )
/* ior_config	*cfg;			 our configuration */
{
    int		result;			/* final return code */

    result = 0;				/* all OK so far */

					/* clear out parsing data areas */
    memset( &cur_pat, '\0', sizeof( ior_pattern ));

    cur_pat.p_start = -1;		/* clear all sizes */
    cur_pat.p_size = -1;
    cur_pat.p_start_pct = -1;		/* clear all percents */
    cur_pat.p_size_pct = -1;
    cur_pat.p_local_size = -1;
    cur_pat.p_local_pct = -1;
    cur_pat.p_local_count = -1;
    cur_pat.p_local_limit = -1;
    cur_pat.p_history = -1;
    cur_pat.p_reuse_pct = -1;
    cur_pat.p_reuse_pct = -1;

    cur_pat.p_read_pct = 100;		/* default is all reads */
    cur_pat.p_is_seq = 1;		/* default is sequential */

    return( result );
}

/*
 * ior_parse_test_clear - clear out test read area
 */
int	ior_parse_test_clear( ior_config *cfg )
/* ior_config	*cfg;			 our configuration */
{
    int		result;			/* final return code */

    result = 0;				/* all OK so far */

					/* clear out parsing data areas */
    memset( &cur_test, '\0', sizeof( ior_test ));

    cur_test.t_start = -1;
    cur_test.t_start_pct = -1;
    cur_test.t_size = -1;
    cur_test.t_size_pct = -1;

    cur_test.t_skew = -1;		/* no skew, by default */
    cur_test.t_seed = IOR_SKEW_SEED;	/* skew seed for randomization */
    cur_test.t_shift = 0;		/* skew is not shifted */
    cur_test.t_correlate = 50;		/* default correlation */
    cur_test.t_area = 4 * 1024 * 1024;	/* default area of 4 MB */

					/* clear pattern percentages */
    for ( parse_cur_pat = 0; parse_cur_pat < IOR_MAX_PATTERNS;
	    parse_cur_pat++ ) {
	parse_pat_pct[ parse_cur_pat ] = 0;
    };

    return( result );
}


/*
 * ior_parse_done - finished parsing the file
 */
int	ior_parse_done( ior_config *cfg )
/* ior_config	*cfg;			 our configuration */
{
    int		result;			/* final return code */

    result = 0;				/* all OK so far */

    sprintf( msg_buf, "Completed parse of file '%s'",
	    cfg->c_l_name );
    ior_debug( cfg, msg_buf );

    parse_cfg = NULL;

    result = ior_lex_done( cfg );

    return( result );
}


/*
 * yyerr_show - show the location of the error we have seen
 *
 *  The trick is to expand any tabs to spaces for alignment
 */
void	yyerr_show( ior_config *cfg )
{
    char	*src;
    char	*tgt;
    int		pos;
    int		tab_chars;

					/* print current line */
    tgt = msg_buf;
    pos = 0;
    tab_chars = 0;
    src = cfg->c_l_cur_txt;
    while (( *src != '\0' ) &&
	    ( *src != '\n' )){

	if ( *src == '\t' ) {		/* expand tabs */
	    do {
		*( tgt++ ) = ' ';
		pos++;
		tab_chars++;
	    } while ( pos % 8 != 0 );
	    tab_chars--;		/* really one less */
	    src++;
	} else {			/* copy others */
	    *( tgt++ ) = *( src++ );
	    pos++;
	};
    };
    *tgt = '\0';			/* end the string */
    ior_msg( cfg, NULL, msg_buf );

					/* point to error */
    sprintf( msg_buf, "%*s^",
	    cfg->c_l_cur_pos + tab_chars - 1, "" );
    ior_msg( cfg, NULL, msg_buf );
};

/*
 * yyerror - clear up an error in the input
 */
int	yyerror( char *s )
{
    if ( feof( yyin )) {		/* on EOF, stop reading */
	sprintf( msg_buf, "%s: line %d: end of file",
		parse_cfg->c_l_name, parse_cfg->c_l_line );
	ior_error( parse_cfg, msg_buf );

    } else if ( parse_cfg->c_l_error[ 0 ]) { /* give LEX error */

			/* print current line & point to error */
	yyerr_show( parse_cfg );
					/* print error */
	sprintf( msg_buf, "%s: line %d: %s",
		parse_cfg->c_l_name, parse_cfg->c_l_line,
		parse_cfg->c_l_error );
	ior_error( parse_cfg, msg_buf );
	parse_cfg->c_l_error[ 0 ] = '\0'; /* drop error now */

    } else {				/* otherwise, give the error */

			/* print current line & point to error */
	yyerr_show( parse_cfg );
					/* print error */
	sprintf( msg_buf, "%s: line %d: %s",
		parse_cfg->c_l_name, parse_cfg->c_l_line, s );
	ior_error( parse_cfg, msg_buf );
    };

    return( 0 );			/* all OK */
}


